PPATH - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on...

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

    1033
    1733     
    3733     
    3739     
    3779
    8779
    8179     
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Example

Input:
3
1033 8179
1373 8017
1033 1033

Output:
6
7
0

hide comments
micku_22: 2023-04-14 07:55:24

weak test cases? or there is no IMPOSSIBLE case?

raziel_: 2022-07-23 04:07:25

@spoj_uddi
xDD lmao
:")

spoj_uddi: 2022-06-27 06:35:40

AC in no go

fuadul_hasan: 2022-03-02 14:41:48

AC in two goes

Last edit: 2023-05-31 22:31:11
raziahmad: 2021-12-04 18:36:54

Notes:
1. Don't post any source code here.
2. Please be careful, leave short comments only. Don't spam here.
3. For more discussion (hints, ideas, solutions) please visit our forum.
4. Authors of the problems are allowed to delete the post and use html code here (e.g. to provide some useful links).

vector_manu: 2021-11-08 18:44:18

AC in One GO!! Use BFS. Check if IMPOSSIBLE case is needed to be considered or not :)

Last edit: 2021-11-08 18:45:01
shubham2912: 2021-10-16 14:05:03

AC in one go..bfs on graph, but i forgot toconsider case for IMPOSSIBLE and instead printed-1 but still AC

darkcry_69: 2021-07-19 14:33:48

I believe the time complexity of intended solution using bfs is O( (no of primes between 1000 and 9999) * 10000).
Tell me if I am wrong.

mani_jo: 2021-06-26 14:54:53

i got RE again and again

kritak: 2021-05-19 06:37:25

@csdeshpande19
8019 is not a prime number. Both the numbers should be prime as mentioned in the problem.


Added by:overwise
Date:2007-10-02
Time limit:2s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO NODEJS PERL6 VB.NET
Resource:ACM ICPC NWERC 2006